source procedure histogram( X@t, tau@t; hx@n) {
    language="java";
    maincode={{
      RegularGridData t = (RegularGridData) X.grid(0);
      RegularGridData n = (RegularGridData) hx.grid(0);
      double[] PDF = new double[n.ct()];
      for (int it=0; it<t.ct()-1; it++) {
         int inx;
         inx=(int)(X.realVal(it));
         if( inx>=0 && inx<=n.ct() ) 
         {PDF[inx]+=(tau.realVal(it+1)-tau.realVal(it));}
      }
      for (int in=0; in<n.ct(); in++) {
         double pdf = PDF[in];
        hx.set(in,pdf);
      }
    }};
}

import nsrunit;
unit conversion on;

math ODE_Brusselator {
realDomain t sec; t.min=0; t.max=233; t.delta=0.1;
real A = 5 mM, B= 30.0 mM; 
real X0= 30 mM,   Y0 = 30 mM;
real X(t) mM, Y(t) mM;
when(t=t.min) {X=X0; Y=Y0;}
real k1 = 0.1 sec^(-1);
real k2 = 0.001 mM^(-2)*sec^(-1);
real k3 = 0.01 mM^(-1)*sec^(-1);
real k4 = 0.1 sec^(-1);

Y:t =-k2*X*X*Y+k3*B*X;
X:t = k1*A+k2*X*X*Y-k3*B*X-k4*X;

// Histograms (positions rounded off to whole numbers)
real tt(t);
tt=t;
realDomain n; n.min=0; n.max=150; n.delta=1;
real hxODE(n), hyODE(n);
histogram(X@t,tt@t,hxODE@n);
histogram(Y@t,tt@t,hyODE@n);
real sumhxODE(n), sumhyODE(n);  // Cumulative distributions
when(n=n.min) {sumhxODE=0;
               sumhyODE=0; }
sumhxODE:n = hxODE/tt(t.max);
sumhyODE:n = hyODE/tt(t.max);
}